package de.unikoblenz.fgbks.base.utils.boundary.checker;

import de.unikoblenz.fgbks.base.utils.boundary.AbstractGrowingBoundary;

public class CheckEqual extends AbstractBoundaryCheck<AbstractGrowingBoundary> {

  private static CheckEqual instance;

  private CheckEqual() {
    super();
  }

  public static CheckEqual getInstance() {
    if (instance == null) {
      instance = new CheckEqual();
    }
    return instance;
  }

  @Override
  public BoundaryCheckType getType() {
    return BoundaryCheckType.IS_EQUAL;
  }

  @Override
  public boolean check(AbstractGrowingBoundary b1, AbstractGrowingBoundary b2) {
    if (b1 == b2) {
      return true;
    }
    if (b1.getText().equals(b2.getText())) {
      return true;
    }
    return ((b1.getLowerBound().equals(b2.getLowerBound())
        && b1.getLowerBoundType().equals(b2.getLowerBoundType())
        && b1.getUpperBound().equals(b2.getUpperBound())
        && b1.getUpperBoundType().equals(b2.getUpperBoundType())));
  }
}
